<template>
  <div class="edit-project">
    <form @submit.prevent="submit">
      <div class="form-field search-user">
        <div class="col-12 md:col-4">
          <div class="p-inputgroup">
            <prime-input-text v-model="domainInput" placeholder="Введите домен конкурента" />
            <prime-button
              type="submit"
              label="Добавить"
            />
          </div>
        </div>
      </div>
    </form>

    <div>
      <div
        v-for="competitor in competitors"
        :key="competitor.id"
        class="competitor"
      >
        <span class="competitor__value">{{ competitor.domain }}</span>
        <prime-button
          icon="pi pi-times"
          class="p-button-rounded p-button-danger p-button-text p-button-sm"
          @click="deleteConfirmation(competitor)"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent, PropType } from 'vue';
import { createCompetitor, deleteCompetitor } from '@/api/handler/competitors';
import { Competitor } from '@/models/competitors';
import { Project } from '@/models/projects';

interface Data {
  domainInput: string;
}

export default defineComponent({
  name: 'edit-competitors',
  components: {
    PrimeButton,
    PrimeInputText,
  },
  props: {
    competitors: { type: Array as PropType<Competitor[]>, required: true },
    project: { type: Object as PropType<Project>, required: true },
  },
  emits: ['close', 'add', 'delete'],
  data(): Data {
    return {
      domainInput: '',
    };
  },
  methods: {
    async submit() {
      const res = await createCompetitor({ domain: this.domainInput, projectId: this.project.id });
      if (res.__state === 'success') {
        this.domainInput = '';
        this.$emit('add', res.data);
      }
    },
    deleteConfirmation(competitor: Competitor) {
      this.$confirm.require({
        message: `Вы уверены, что хотите удалить конкурента "${competitor.domain}"? Все данные, связанные с этим конкурентом, будут потеряны!`,
        header: `Удаление конкурента "${competitor.domain}"`,
        icon: 'pi pi-exclamation-triangle',
        accept: () => {
          this.deleteCompetitor(competitor);
        },
      });
    },
    async deleteCompetitor({ id }: Competitor) {
      const res = await deleteCompetitor({ id });
      if (res.__state === 'success') {
        this.$emit('delete', id);
      }
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}

.competitor {
    display: flex;
    align-items: center;

    &__email {
        flex: 1 1 auto;
    }
}
</style>
